Function initGlobal();
Function unloadGlobal();
Function showActionInfo(String strValue);
Function setSongTicker();
Function debugAlert(String strValue);

Global String strSkinName;
Global Container containerMain;
Global Container containerPL;
Global Layout layoutMainHandheld, layoutMainSphere, layoutMainNormal, layoutMainShade;
Global Layout layoutPLShade;
Global Text textHandheldSongInfo, textSphereSongInfo, textNormalSongInfo, textShadeSongInfo;
Global Text textHandheldActionInfo, textSphereActionInfo, textNormalActionInfo, textShadeActionInfo;
Global Timer timerSongTicker;
Global Boolean boolReleaseSongTicker;
Global Boolean boolSongTicker;

initGlobal() {
	strSkinName = "Venus";
	
	containerMain = System.getContainer("main");
	containerPL = System.getContainer("PLEdit");
	
	layoutMainHandheld = containerMain.getLayout("handheld");
	layoutMainSphere = containerMain.getLayout("sphere");
	layoutMainNormal = containerMain.getLayout("normal");
	layoutMainShade = containerMain.getLayout("shade");
	
	layoutPLShade = containerPL.getLayout("shade");

	textHandheldSongInfo = layoutMainHandheld.findObject("player.display.songname");
	textHandheldActionInfo = layoutMainHandheld.findObject("player.display.actioninfo");
	
	textSphereSongInfo = layoutMainSphere.findObject("player.display.songname");
	textSphereActionInfo = layoutMainSphere.findObject("player.display.actioninfo");	
	
	textNormalSongInfo = layoutMainNormal.findObject("player.display.songname");
	textNormalActionInfo = layoutMainNormal.findObject("player.display.actioninfo");
	
	textShadeSongInfo = layoutMainShade.findObject("player.display.songname");
	textShadeActionInfo = layoutMainShade.findObject("player.display.actioninfo");
	
	textHandheldActionInfo.hide();
	textSphereActionInfo.hide();
	textNormalActionInfo.hide();
	textShadeActionInfo.hide();
	
	timerSongTicker = new Timer;
	timerSongTicker.setDelay(1000);
	boolReleaseSongTicker = true;
	
	boolSongTicker = System.getPrivateInt(strSkinName, "SongTicker", 1);
	setSongTicker();
}

unloadGlobal() {
	delete timerSongTicker;
}

timerSongTicker.onTimer() {
	if (boolReleaseSongTicker) {
		textHandheldActionInfo.hide();
		textSphereActionInfo.hide();
		textNormalActionInfo.hide();
		textShadeActionInfo.hide();
		
		textHandheldSongInfo.show();
		textSphereSongInfo.show();
		textNormalSongInfo.show();
		textShadeSongInfo.show();
		
		timerSongTicker.stop();
	}
}

showActionInfo(String strValue) {
	timerSongTicker.stop();
	timerSongTicker.start();
	
	textHandheldSongInfo.hide();
	textHandheldActionInfo.show();
	textHandheldActionInfo.setText(strValue);
	
	textSphereSongInfo.hide();
	textSphereActionInfo.show();
	textSphereActionInfo.setText(strValue);
	
	textNormalSongInfo.hide();
	textNormalActionInfo.show();
	textNormalActionInfo.setText(strValue);
	
	textShadeSongInfo.hide();
	textShadeActionInfo.show();
	textShadeActionInfo.setText(strValue);
}

setSongTicker() {
	textHandheldSongInfo.setXMLParam("ticker", System.integerToString(boolSongTicker));
	textSphereSongInfo.setXMLParam("ticker", System.integerToString(boolSongTicker));
	textNormalSongInfo.setXMLParam("ticker", System.integerToString(boolSongTicker));
	textShadeSongInfo.setXMLParam("ticker", System.integerToString(boolSongTicker));
	
	System.setPrivateInt(strSkinName, "SongTicker", boolSongTicker);
}

debugAlert(String strValue) {
	messageBox(strValue, "Debug Alert", 0, "");
}