Function lightsUpdate(Int intLeftValue, Int intRightValue);
Function lightsUpdateUtil(Layer layerVis, Int intValue);
Function initLights();
Function unloadLights();

Global Layer layerHandheldVisLightsLeft, layerHandheldVisLightsRight;
Global Layer layerSphereVisLightsLeft, layerSphereVisLightsRight;
Global Layer layerNormalVisLightsLeft, layerNormalVisLightsRight;
Global Timer timerVisLights;

Global Int intDefaultLightsRefreshRate;
Global Int intDefaultLightsFalloffRate;
Global Int intDefaultLightsEnabled;

Global Int intCurrentLightsRefreshRate;
Global Int intCurrentLightsFalloffRate;
Global Int intCurrentLightsEnabled;

initLights() {
	layerHandheldVisLightsLeft = layoutMainHandheld.findObject("player.vent.left.light");
	layerHandheldVisLightsRight = layoutMainHandheld.findObject("player.vent.right.light");
	layerSphereVisLightsLeft = layoutMainSphere.findObject("player.vent.left.light");
	layerSphereVisLightsRight = layoutMainSphere.findObject("player.vent.right.light");
	layerNormalVisLightsLeft = layoutMainNormal.findObject("player.vent.left.light");
	layerNormalVisLightsRight = layoutMainNormal.findObject("player.vent.right.light");	
	
	intDefaultLightsRefreshRate = 51;
	intDefaultLightsFalloffRate = 51;
	intDefaultLightsEnabled = 1;
	
	intCurrentLightsRefreshRate = intDefaultLightsRefreshRate;
	intCurrentLightsFalloffRate = intDefaultLightsFalloffRate;
	intCurrentLightsEnabled = intDefaultLightsEnabled;
	
	timerVisLights = new Timer;
	timerVisLights.setDelay(intCurrentLightsRefreshRate);
	timerVisLights.start();
}

unloadLights() {
	delete timerVisLights;
}

timerVisLights.onTimer() {
	timerVisLights.setDelay(intCurrentLightsRefreshRate);
	lightsUpdate(System.getLeftVuMeter(), System.getRightVuMeter());
}

lightsUpdate(Int intLeftValue, Int intRightValue) {
	lightsUpdateUtil(layerHandheldVisLightsLeft, intLeftValue);
	lightsUpdateUtil(layerHandheldVisLightsRight, intRightValue);
	lightsUpdateUtil(layerSphereVisLightsLeft, intLeftValue);
	lightsUpdateUtil(layerSphereVisLightsRight, intRightValue);
	lightsUpdateUtil(layerNormalVisLightsLeft, intLeftValue);
	lightsUpdateUtil(layerNormalVisLightsRight, intRightValue);
}

lightsUpdateUtil(Layer layerVis, Int intValue) {
	if (intValue > layerVis.getAlpha() && intCurrentLightsEnabled) {
		layerVis.setAlpha(intValue);
		layerVis.setTargetA(0);
		layerVis.setTargetSpeed(intCurrentLightsFalloffRate / 100);
		layerVis.gotoTarget();
	}	
}