Function initSeek();
Function unloadSeek();
Function seekUpdate(Int intNewPosition);
Function seekUpdateUtil(Int intNewPosition, Map mapSeek, Layer layerSeekHandle);
Function seekUpdateXY(Int intPosX, Int intPosY, Map mapSeek, Layer layerSeekHandle, Text textSongTicker, Text textSeekTicker);
Function seekUpdateRegion(Layer layerSeekHandle, Map mapSeek, Float floatPosition);
Function seekMoveTo(Int intPosX, Int intPosY, Map mapSeek);
Function layerSeekTrackLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapSeek, Layer layerSeekHandle, Text textSongTicker, Text textSeekTicker);
Function layerSeekTrackMouseMoveUtil(Int intPosX, Int intPosY, Map mapSeek, Layer layerSeekHandle, Text textSongTicker, Text textSeekTicker);
Function layerSeekTrackLeftButtonUpUtil(Int intPosX, Int intPosY, Map mapSeek);

Global Layer layerHandheldSeekTrack, layerHandheldSeekHandle;
Global Layer layerSphereSeekTrack, layerSphereSeekHandle;
Global Map mapHandheldSeek, mapSphereSeek;
Global Timer timerSeek;
Global Int intSeekClicked;
Global Int intCurrentPosition;
Global Region regionSeek;

initSeek() {
	layerHandheldSeekTrack = layoutMainHandheld.findObject("player.display.seek.track");
	layerHandheldSeekHandle = layoutMainHandheld.findObject("player.display.seek.handle");
	
	layerSphereSeekTrack = layoutMainSphere.findObject("player.display.seek.track");
	layerSphereSeekHandle = layoutMainSphere.findObject("player.display.seek.handle");
	
	mapHandheldSeek = new Map;
	mapHandheldSeek.loadMap("player.handheld.display.map");
	
	mapSphereSeek = new Map;
	mapSphereSeek.loadMap("player.sphere.display.map");

	regionSeek = new Region;
	
	seekUpdate(0);
	
	timerSeek = new Timer;
	timerSeek.setDelay(150);
	timerSeek.start();
}

unloadSeek() {
	delete timerSeek;
	delete mapHandheldSeek;
	delete mapSphereSeek;
	delete regionSeek;
}

timerSeek.onTimer() {
	if (intSeekClicked) return;
	Int intPlayItemLength = System.getPlayItemLength();
	if (intPlayItemLength > 0) {
		Int intPosition = System.getPosition() / intPlayItemLength * 255;
		if (intPosition != intCurrentPosition) {
			seekUpdate(System.getPosition());
		}
	} else {
		if (intCurrentPosition != 0) {
			seekUpdate(0);
			intCurrentPosition = 0;
		}
	}
}

seekUpdate(Int intNewPosition) {
	seekUpdateUtil(intNewPosition, mapHandheldSeek, layerHandheldSeekHandle);
	seekUpdateUtil(intNewPosition, mapSphereSeek, layerSphereSeekHandle);
}

seekUpdateUtil(Int intNewPosition, Map mapSeek, Layer layerSeekHandle) {
	Float floatPosition;
	Int intPlayItemLength = System.getPlayItemLength();
	if (intPlayItemLength == 0) {
		floatPosition = 0;
	} else {
		floatPosition = intNewPosition / intPlayItemLength * 255;
	}
	intCurrentPosition = floatPosition;
	seekUpdateRegion(layerSeekHandle, mapSeek, floatPosition);
}

seekUpdateXY(Int intPosX, Int intPosY, Map mapSeek, Layer layerSeekHandle, Text textSongTicker, Text textSeekTicker) {
	Int intPosition = mapSeek.getValue(intPosX, intPosY);
	seekUpdateRegion(layerSeekHandle, mapSeek, intPosition);
	
	Float floatPositionPercentage = intPosition / 255 * 100;
	Float floatPlayItemLength = System.getPlayItemLength();
	Int intNewPosition = floatPlayItemLength * floatPositionPercentage / 100;
	showActionInfo(System.integerToTime(intNewPosition) + " / " + System.integerToTime(floatPlayItemLength));
}

seekUpdateRegion(Layer layerSeekHandle, Map mapSeek, Float floatPosition) {
	regionSeek.loadFromMap(mapSeek, floatPosition, 1);
	regionSeek.offset(-layerSeekHandle.getLeft(), -layerSeekHandle.getTop());
	layerSeekHandle.setRegion(regionSeek);
}

seekMoveTo(Int intPosX, Int intPosY, Map mapSeek) {
	Int intPosition = mapSeek.getValue(intPosX, intPosY);
	System.seekTo(System.getPlayItemLength() * (intPosition / 255));
}

layerHandheldSeekTrack.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerSeekTrackLeftButtonDownUtil(intPosX, intPosY, mapHandheldSeek, layerHandheldSeekHandle, textHandheldSongInfo, textHandheldActionInfo);
}
layerSphereSeekTrack.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerSeekTrackLeftButtonDownUtil(intPosX, intPosY, mapSphereSeek, layerSphereSeekHandle, textSphereSongInfo, textSphereActionInfo);
}
layerSeekTrackLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapSeek, Layer layerSeekHandle, Text textSongTicker, Text textSeekTicker) {
	if (System.getPlayItemLength() <= 0) return;
	if (strLeft(System.getPlayItemString(), 4) == "http") return;
	intSeekClicked = 1;
	boolReleaseSongTicker = false;
	seekUpdateXY(intPosX, intPosY, mapSeek, layerSeekHandle, textSongTicker, textSeekTicker);
}

layerHandheldSeekTrack.onMouseMove(Int intPosX, Int intPosY) {
	layerSeekTrackMouseMoveUtil(intPosX, intPosY, mapHandheldSeek, layerHandheldSeekHandle, textHandheldSongInfo, textHandheldActionInfo);
}
layerSphereSeekTrack.onMouseMove(Int intPosX, Int intPosY) {
	layerSeekTrackMouseMoveUtil(intPosX, intPosY, mapSphereSeek, layerSphereSeekHandle, textSphereSongInfo, textSphereActionInfo);
}
layerSeekTrackMouseMoveUtil(Int intPosX, Int intPosY, Map mapSeek, Layer layerSeekHandle, Text textSongTicker, Text textSeekTicker) {
	if (intSeekClicked) {
		if (System.getPlayItemLength() == 0) {
			intSeekClicked = 0;
			boolReleaseSongTicker = true;
			return;
		}
		seekUpdateXY(intPosX, intPosY, mapSeek, layerSeekHandle, textSongTicker, textSeekTicker);
	}
}

layerHandheldSeekTrack.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerSeekTrackLeftButtonUpUtil(intPosX, intPosY, mapHandheldSeek);
}
layerSphereSeekTrack.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerSeekTrackLeftButtonUpUtil(intPosX, intPosY, mapSphereSeek);
}
layerSeekTrackLeftButtonUpUtil(Int intPosX, Int intPosY, Map mapSeek) {
	if (!intSeekClicked) return;
	intSeekClicked = 0;
	boolReleaseSongTicker = true;
	seekMoveTo(intPosX, intPosY, mapSeek);
}