Function initVolume();
Function unloadVolume();
Function volumeUpdate();
Function volumeUpdateUtil(Map mapVolume, Layer layerVolumeHandle);
Function volumeUpdateXY(Int intPosX, Int intPosY, Map mapVolume, Layer layerVolumeHandle, Text textSongTicker, Text textVolumeTicker);
Function volumeUpdateRegion(Layer layerVolumeHandle, Map mapVolume, Float floatVolume);
Function layerVolumeTrackLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapVolume, Layer layerVolumeHandle, Text textSongTicker, Text textVolumeTicker);
Function layerVolumeTrackMouseMoveUtil(Int intPosX, Int intPosY, Map mapVolume, Layer layerVolumeHandle, Text textSongTicker, Text textVolumeTicker);
Function layerVolumeTrackLeftButtonUpUtil(Int intPosX, Int intPosY);
Function volumeUpdateTicker(Int intVolume, Text textSongTicker, Text textVolumeTicker);

Global Layer layerHandheldVolumeTrack, layerHandheldVolumeHandle;
Global Layer layerSphereVolumeTrack, layerSphereVolumeHandle;
Global Map mapHandheldVolume, mapSphereVolume;
Global Int intVolumeClicked;
Global Int intCurrentVolume;
Global Region regionVolume;

initVolume() {
	layerHandheldVolumeTrack = layoutMainHandheld.findObject("player.display.volume.track");
	layerHandheldVolumeHandle = layoutMainHandheld.findObject("player.display.volume.handle");

	layerSphereVolumeTrack = layoutMainSphere.findObject("player.display.volume.track");
	layerSphereVolumeHandle = layoutMainSphere.findObject("player.display.volume.handle");
	
	mapHandheldVolume = new Map;
	mapHandheldVolume.loadMap("player.handheld.display.map");
	
	mapSphereVolume = new Map;
	mapSphereVolume.loadMap("player.sphere.display.map");
	
	regionVolume = new Region;
	
	volumeUpdate();
}

unloadVolume() {
	delete mapHandheldVolume;
	delete mapSphereVolume;
	delete regionVolume;
}

System.onVolumeChanged(Int intVolume) {
	volumeUpdate();
	volumeUpdateTicker(intVolume, textHandheldSongInfo, textHandheldActionInfo);
	volumeUpdateTicker(intVolume, textSphereSongInfo, textSphereActionInfo);
}

volumeUpdate() {
	volumeUpdateUtil(mapHandheldVolume, layerHandheldVolumeHandle);
	volumeUpdateUtil(mapSphereVolume, layerSphereVolumeHandle);
}

volumeUpdateUtil(Map mapVolume, Layer layerVolumeHandle) {
	intCurrentVolume = System.getVolume();
	volumeUpdateRegion(layerVolumeHandle, mapVolume, intCurrentVolume);
}

volumeUpdateXY(Int intPosX, Int intPosY, Map mapVolume, Layer layerVolumeHandle, Text textSongTicker, Text textVolumeTicker) {
	Int intVolume = mapVolume.getValue(intPosX, intPosY) + 1;
	volumeUpdateRegion(layerVolumeHandle, mapVolume, intVolume);
	System.setVolume(intVolume - 1);
	volumeUpdateTicker(intVolume, textSongTicker, textVolumeTicker);
}

volumeUpdateRegion(Layer layerVolumeHandle, Map mapVolume, Float floatVolume) {
	regionVolume.loadFromMap(mapVolume, floatVolume, 1);
	regionVolume.offset(-layerVolumeHandle.getLeft(), -layerVolumeHandle.getTop());
	layerVolumeHandle.setRegion(regionVolume);
}

volumeUpdateTicker(Int intVolume, Text textSongTicker, Text textVolumeTicker) {
	showActionInfo("VOLUME:" + System.integerToString(intVolume / 255 * 100) + "%");
}

layerHandheldVolumeTrack.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerVolumeTrackLeftButtonDownUtil(intPosX, intPosY, mapHandheldVolume, layerHandheldVolumeHandle, textHandheldSongInfo, textHandheldActionInfo);
}
layerSphereVolumeTrack.onLeftButtonDown(Int intPosX, Int intPosY) {
	layerVolumeTrackLeftButtonDownUtil(intPosX, intPosY, mapSphereVolume, layerSphereVolumeHandle, textSphereSongInfo, textSphereActionInfo);
}
layerVolumeTrackLeftButtonDownUtil(Int intPosX, Int intPosY, Map mapVolume, Layer layerVolumeHandle, Text textSongTicker, Text textVolumeTicker) {
	intVolumeClicked = 1;
	boolReleaseSongTicker = false;
	volumeUpdateXY(intPosX, intPosY, mapVolume, layerVolumeHandle, textSongTicker, textVolumeTicker);
}

layerHandheldVolumeTrack.onMouseMove(Int intPosX, Int intPosY) {
	layerVolumeTrackMouseMoveUtil(intPosX, intPosY, mapHandheldVolume, layerHandheldVolumeHandle, textHandheldSongInfo, textHandheldActionInfo);
}
layerSphereVolumeTrack.onMouseMove(Int intPosX, Int intPosY) {
	layerVolumeTrackMouseMoveUtil(intPosX, intPosY, mapSphereVolume, layerSphereVolumeHandle, textSphereSongInfo, textSphereActionInfo);
}
layerVolumeTrackMouseMoveUtil(Int intPosX, Int intPosY, Map mapVolume, Layer layerVolumeHandle, Text textSongTicker, Text textVolumeTicker) {
	if (intVolumeClicked) {
		volumeUpdateXY(intPosX, intPosY, mapVolume, layerVolumeHandle, textSongTicker, textVolumeTicker);
	}
}

layerHandheldVolumeTrack.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerVolumeTrackLeftButtonUpUtil(intPosX, intPosY);
}
layerSphereVolumeTrack.onLeftButtonUp(Int intPosX, Int intPosY) {
	layerVolumeTrackLeftButtonUpUtil(intPosX, intPosY);
}
layerVolumeTrackLeftButtonUpUtil(Int intPosX, Int intPosY) {
	if (!intVolumeClicked) return;
	intVolumeClicked = 0;
	boolReleaseSongTicker = true;
}